<?php
function music(){
    $inCore = cmsCore::getInstance();
    $inPage = cmsPage::getInstance();
    $inDB = cmsDatabase::getInstance();
    $inUser = cmsUser::getInstance();
    
    cmsCore::loadModel('music');
    $model = new cms_model_music();
    
    $inPage->addHeadJS('components/music/js-css/musics.js');
//    $inPage->addHeadCSS('components/music/js-css/jquery.rating.css');

    $inPage->addPathway('Музыка', '/music');
    $page = cmsCore::request('page', 'int', '1');

    if ($inCore->do == 'index' or $inCore->do == 'view'){
        $model->inDB->orderBy($model->config['music_order_by'], $model->config['music_order_to']);
        $model->inDB->limitPage($page, $model->config['music_perpage']);
        
        $total = $model->getMusicTotal();
        $musics = $model->getMusic();

        $inPage->setTitle($model->config['music_pagetitle']);
        $inPage->setDescription($model->config['music_metadesc']);
        $inPage->setKeywords($model->config['music_metakeys']);

        cmsPage::initTemplate('components', 'com_music_index.tpl')->
            assign('do', $inCore->do)->
            assign('user_id', $inUser->id)->
            assign('is_admin', $inUser->is_admin)->
            assign('pleer', $model->config['player'])->
            assign('total', $total)->
            assign('musics', $musics)->
            assign('pagebar', cmsPage::getPagebar($total, $page, $model->config['music_perpage'], '/music/page-%page%'))->
            display('com_music_index.tpl');
    }

    if ($inCore->do == 'view_music'){
        $music_index = cmsCore::request('music_index', 'int', 0);
        $music = $model->getMus($music_index);
        if (empty($music)){ cmsCore::error404(); }
        
        $inPage->setTitle($music['singer'] .' - '. $music['name']);
        $inPage->addPathway($music['singer'] .' - '. $music['name']);
        
        cmsPage::initTemplate('components', 'com_music_view.tpl')->
            assign('do', $inCore->do)->
            assign('user_id', $inUser->id)->
            assign('is_admin', $inUser->is_admin)->
            assign('pleer', $model->config['one_player'])->
            assign('music', $music)->
            display('com_music_view.tpl');

        $inCore->includeComments();
        comments('music', $music_index);
    }

    if ($inCore->do == 'my'){
        $model->inDB->orderBy($model->config['music_order_by'], $model->config['music_order_to']);
//        $model->inDB->limitPage($page, $model->config['music_perpage']);
        $model->inDB->where("m.user_id='". $inUser->id ."'");
        $musics = $model->getMusic();
        
        $inPage->setTitle('Моя Музыка');
        $inPage->addPathway('Моя Музыка');
        
        cmsPage::initTemplate('components', 'com_music_my.tpl')->
            assign('do', $inCore->do)->
            assign('user_id', $inUser->id)->
            assign('is_admin', $inUser->is_admin)->
            assign('pleer', $model->config['player'])->
            assign('musics', $musics)->
            display('com_music_my.tpl');
    }

    if ($inCore->do == 'add'){
        if (!$inUser->id){
            cmsCore::addSessionMessage('Для добавления песен на сайт вам необходимо зарегистрироваться.', 'error');
            cmsCore::redirectBack();
        }

        if (!cmsCore::inRequest('send')){
            cmsPage::initTemplate('components', 'com_music_add.tpl')->
                assign('do', $inCore->do)->
                assign('user_id', $inUser->id)->
                assign('is_admin', $inUser->is_admin)->
                assign('genres', $model->getGenre())->
                display('com_music_add.tpl');
        }else{
            $name = cmsCore::request('name', 'str');
            $singer = cmsCore::request('singer', 'str');
            $album = cmsCore::request('album', 'str');
            $genre_id = cmsCore::request('genre_id', 'str');
            $upload = cmsCore::inRequest('upload');
            $user_id = $inUser->id;

            if (!$name){
                cmsCore::addSessionMessage('Укажите название песни!', 'error');
                cmsCore::redirectBack();
            }

            if (!$singer){
                cmsCore::addSessionMessage('Укажите Исполнителя песни!', 'error');
                cmsCore::redirectBack();
            }

            if (!$album){
                $album = 'Без Альбома';
            }

            $album_id = $model->getAlbumId($album);
            if (!$album_id) {
                $album_id = $model->addAlbum($album, $user_id);
            }

            $singer_id = $model->getSingerId($singer);
            if (!$singer_id) {
                $singer_id = $model->addSinger($singer, $user_id);
            }

            if ($upload) {
                $realfile = $_FILES['upmp3']['name'];
                $path_parts = pathinfo($realfile);
                $ext = strtolower($path_parts['extension']);

                if ($ext == 'mp3'){
                    $upload_dir = PATH .'/upload/musics/'. $user_id;
                    @mkdir($upload_dir);

                    $filename = md5($realfile .'-'. $user_id .'-'. time()) .'.mp3';
                    $uploadfile = $upload_dir .'/'. $filename;
                    $source = $_FILES['upmp3']['tmp_name'];
                    $errorCode = $_FILES['upmp3']['error'];

                    if (cmsCore::moveUploadedFile($source, $uploadfile, $errorCode)){
                        $music_url = '/upload/musics/'. $user_id .'/'. $filename;
                    }else{
                        cmsCore::addSessionMessage('Ошибка Загрузки Файла!', 'error');
                        cmsCore::redirectBack();
                    }
                }else{
                    cmsCore::addSessionMessage('Недопустимый Формат Файла!', 'error');
                    cmsCore::redirectBack();
                }

                $music_id = $model->addMusic($name, $singer_id, $album_id, $genre_id, $user_id, $music_url);
            }else{
                $music_url = cmsCore::request('upmp3', 'str');
                $music_id = $model->addMusic($name, $singer_id, $album_id, $genre_id, $user_id, $music_url);
            }

            if ($music_id){
                cmsCore::addSessionMessage('Песня успешно добавлена!', 'success');
            }

            if (!$music_id){
                cmsCore::addSessionMessage('Ощибка добавления песни!', 'error');
            }

            cmsCore::redirect('/music');
        }

    }

    if ($inCore->do == 'delete'){
        if (!$inUser->id){ cmsCore::error404(); }
        
        $music_id = cmsCore::request('mus', 'int');
        $model->deleteMusic($music_id);
        
        cmsCore::redirectBack();
    }

    if ($inCore->do == 'addmuspl'){
        if (!$inUser->id){ cmsCore::error404(); }
        
        $music_id = cmsCore::request('mus', 'int');

        $result = $model->addmuspl($music_id, $inUser->id);

        if ($result == 1){
            cmsCore::halt('Ошибка! Эта песня уже находится в вашем плейлисте.');
        }

        if ($result == 2){
            cmsCore::halt('Ошибка! Ваш плейлист заполнен.');
        }

        if ($result == 3){
            cmsCore::halt('Песня успешно добавлена в ваш плейлист.');
        }
    }

    if ($inCore->do == 'delmuspl'){
        $music_id = cmsCore::request('mus', 'int');
        if (!$inUser->id && empty($music_id)){ cmsCore::error404(); }

        $result = $model->delmuspl($music_id,$inUser->id);
        cmsCore::halt($result === true ? 'ok' : 'ERROR');
    }

    if ($inCore->do == 'listen'){
        $music_id = cmsCore::request('mus', 'int');
        if (empty($music_id)){ cmsCore::error404(); }
        $model->listen($music_id);
        cmsCore::halt();
    }

    if ($inCore->do == 'listened'){
        $music_id = cmsCore::request('mus', 'int');
        if (empty($music_id)){ cmsCore::error404(); }
        $model->listened($music_id);
        cmsCore::halt();
    }

    if ($inCore->do == 'view_album'){
        $album_id = cmsCore::request('album_index', 'int', 0);
        $album = $model->getAlbum($album_id);
        if (empty($album)){ cmsCore::error404(); }
        
        $model->inDB->orderBy($model->config['music_order_by'], $model->config['music_order_to']);
        $model->inDB->limitPage($page, $model->config['music_perpage']);
        $model->inDB->where("m.album_id='". $album_id ."'");
        $musics = $model->getMusic();

        $sql = "SELECT id FROM cms_music WHERE album_id = '{$album_id}'";
        $total = $inDB->num_rows($inDB->query($sql));

        $inPage->setTitle($album['album_name']);
        $inPage->addPathway('Альбомы', '/music/albums');
        $inPage->addPathway($album['album_name']);

        cmsPage::initTemplate('components', 'com_music_album.tpl')->
            assign('do', $inCore->do)->
            assign('user_id', $inUser->id)->
            assign('is_admin', $inUser->is_admin)->
            assign('album', $album)->
            assign('musics', $musics)->
            assign('pleer', $model->config['player'])->
            assign('pagebar', cmsPage::getPagebar($total, $page, $model->config['music_perpage'], '/music/album'. $album_id .'-page%page%'))->
            display('com_music_album.tpl');
    }

    if ($inCore->do == 'view_singer'){
        $singer_id = cmsCore::request('singer_index', 'int', 0);
        $singer = $model->getSinger($singer_id);
        if (empty($singer)){ cmsCore::error404(); }
        
        $model->inDB->orderBy($model->config['music_order_by'], $model->config['music_order_to']);
        $model->inDB->limitPage($page, $model->config['music_perpage']);
        $model->inDB->where("m.singer_id='". $singer_id ."'");
        
        $total = $model->getMusicTotal();
        $musics = $model->getMusic();

        $inPage->setTitle($singer['singer_name']);
        $inPage->addPathway('Исполнители', '/music/singers');
        $inPage->addPathway($singer['singer_name']);
        
        cmsPage::initTemplate('components', 'com_music_singer.tpl')->
            assign('do', $inCore->do)->
            assign('user_id', $inUser->id)->
            assign('is_admin', $inUser->is_admin)->
            assign('singer', $singer)->
            assign('musics', $musics)->
            assign('pleer', $model->config['player'])->
            assign('pagebar', cmsPage::getPagebar($total, $page, $model->config['music_perpage'], '/music/singer'. $singer_id .'-page%page%'))->
            display('com_music_singer.tpl');
    }

    if ($inCore->do == 'view_singers'){
        $total = $model->getSingersTotal();
        $singers = $model->getSingers($page, $model->config['singers_perpage']);

        $inPage->addPathway('Исполнители');
        
        $inPage->setTitle($model->config['singers_pagetitle']);
        $inPage->setDescription($model->config['singers_metadesc']);
        $inPage->setKeywords($model->config['singers_metakeys']);
        
        cmsPage::initTemplate('components', 'com_music_list.tpl')->
            assign('do', $inCore->do)->
            assign('user_id', $inUser->id)->
            assign('is_admin', $inUser->is_admin)->
            assign('singers', $singers)->
            assign('pagebar', cmsPage::getPagebar($total, $page, $model->config['singers_perpage'], '/music/singers-page%page%'))->
            display('com_music_list.tpl');
    }

    if ($inCore->do == 'view_albums'){
        $total = $model->getAlbumsTotal();
        $albums = $model->getAlbums($page, $model->config['albums_perpage']);

        $inPage->addPathway('Альбомы');
        
        $inPage->setTitle($model->config['albums_pagetitle']);
        $inPage->setDescription($model->config['albums_metadesc']);
        $inPage->setKeywords($model->config['albums_metakeys']);
        
        cmsPage::initTemplate('components', 'com_music_list.tpl')->
            assign('do', $inCore->do)->
            assign('user_id', $inUser->id)->
            assign('is_admin', $inUser->is_admin)->
            assign('albums', $albums)->
            assign('pagebar', cmsPage::getPagebar($total, $page, $model->config['albums_perpage'], '/music/albums-page%page%'))->
            display('com_music_list.tpl');
    }

    if ($inCore->do == 'edit_album'){
        if ($inUser->is_admin){
            $album_id = cmsCore::request('album_index', 'int', 0);
            $album = $model->getAlbum($album_id);
            if (empty($album)){ cmsCore::error404(); }

            if (!cmsCore::inRequest('send')){
                cmsPage::initTemplate('components', 'com_music_album_edit.tpl')->
                    assign('do', $inCore->do)->
                    assign('user_id', $inUser->id)->
                    assign('is_admin', $inUser->is_admin)->
                    assign('album', $album)->
                    display('com_music_album_edit.tpl');
            }else{
                $album_name = cmsCore::request('album', 'str', $album['album_name']);
                $album_description = cmsCore::request('description', 'str', '');

                $uploaddir = PATH .'/images/music/album/';		
                $realfile = $_FILES['photo']['name'];
                $path_parts = pathinfo($realfile);
                $ext = strtolower($path_parts['extension']);

                if ($realfile){
                    $inCore->includeGraphics();
                    if ($ext != 'jpg' and $ext != 'jpeg' and $ext != 'gif' and $ext != 'bmp' and $ext != 'png'){
                        cmsCore::addSessionMessage('Ошибка! Расширение фото должно быть: <b>.jpg</b>  <b>.jpeg</b>  <b>.gif</b>  <b>.bmp</b>  <b>.png</b><br/>', 'error');
                        cmsCore::redirectBack();
                    }
                    
                    if (!empty($album['photo'])){
                        unlink($uploaddir . $album['photo']);
                        unlink($uploaddir .'mini/'. $album['photo']);
                    }
                    
                    $filename = md5($realfile .'-'. $album_id .'-'. time()) .'.jpg';
                    $uploadfile = $uploaddir . $realfile;
                    $uploadphoto = $uploaddir . $filename;
                    $uploadthumb = $uploaddir .'mini/'. $filename;

                    $source = $_FILES['photo']['tmp_name'];
                    $errorCode = $_FILES['photo']['error'];

                    $inCore->moveUploadedFile($source, $uploadfile, $errorCode);

                    $smallw = 100;
                    $medw = 450;
                    $medh = 400;

                    @img_resize($uploadfile, $uploadphoto, $medw, $medh);
                    @img_resize($uploadfile, $uploadthumb, $smallw, $smallw);

                    unlink($uploadfile);

                    $model->EditAlbum($album_id, $album_name, $album_description, $filename);
                    cmsCore::redirect('/music/album'. $album_id);
                }else{
                    $model->EditAlbum($album_id, $album_name, $album_description);
                    cmsCore::redirect('/music/album'. $album_id);
                }
            }
        }else{
            cmsCore::redirect('/music');
        }
    }

    if ($inCore->do == 'edit_singer'){
        if ($inUser->is_admin){
            $singer_id = cmsCore::request('singer_index', 'int', 0);
            $singer = $model->getSinger($album_id);
            if (empty($singer)){ cmsCore::error404(); }
            
            if (!cmsCore::inRequest('send')){
                cmsPage::initTemplate('components', 'com_music_singer_edit.tpl')->
                    assign('do', $inCore->do)->
                    assign('user_id', $inUser->id)->
                    assign('is_admin', $inUser->is_admin)->
                    assign('singer', $singer)->
                    display('com_music_singer_edit.tpl');
            }else{
                $singer_name = cmsCore::request('singer', 'str', $singer['singer_name']);
                $singer_description = cmsCore::request('description', 'str', '');

                $uploaddir = PATH .'/images/music/singer/';		
                $realfile = $_FILES['photo']['name'];
                $path_parts = pathinfo($realfile);
                $ext = strtolower($path_parts['extension']);

                if ($realfile){
                    $inCore->includeGraphics();
                    if ($ext != 'jpg' and $ext != 'jpeg' and $ext != 'gif' and $ext != 'bmp' and $ext != 'png'){
                        cmsCore::addSessionMessage('Ошибка! Расширение фото должно быть: <b>.jpg</b>  <b>.jpeg</b>  <b>.gif</b>  <b>.bmp</b>  <b>.png</b><br/>', 'error');
                        cmsCore::redirectBack();
                    }

                    if (!empty($singer['photo'])){
                        unlink($uploaddir . $singer['photo']);
                        unlink($uploaddir .'mini/'. $singer['photo']);
                    }
                    
                    $filename = md5($realfile .'-'. $singer_id .'-'. time()) .'.jpg';
                    $uploadfile = $uploaddir . $realfile;
                    $uploadphoto = $uploaddir . $filename;
                    $uploadthumb = $uploaddir .'mini/'. $filename;

                    $source = $_FILES['photo']['tmp_name'];
                    $errorCode = $_FILES['photo']['error'];

                    $inCore->moveUploadedFile($source, $uploadfile, $errorCode);

                    $smallw = 100;
                    $medw = 220;
                    $medh = 250;

                    @img_resize($uploadfile, $uploadphoto, $medw, $medh);
                    @img_resize($uploadfile, $uploadthumb, $smallw, $smallw);

                    unlink($uploadfile);

                    $model->EditSinger($singer_id, $singer_name, $singer_description, $filename);
                    cmsCore::redirect('/music/singer'. $singer_id);
                }else{
                    $model->EditSinger($singer_id, $singer_name, $singer_description);
                    cmsCore::redirect('/music/singer'.$singer_id);
                }
            }
        }else{
            cmsCore::redirect('/music');
        }
    }

    if ($inCore->do == 'mypl'){
        if (!$inUser->id){ cmsCore::error404(); }
        
        if (!$model->getPl($inUser->id)){
            $model->addPl($inUser->id);
        }

        $musics = $model->getMusPl($inUser->id);

        $inPage->setTitle("Мой Плейлист");
        $inPage->addPathway('Мой плейлист');

        cmsPage::initTemplate('components', 'com_music_mypl.tpl')->
            assign('do', $inCore->do)->
            assign('user_id', $inUser->id)->
            assign('is_admin', $inUser->is_admin)->
            assign('musics', $musics)->
            assign('pleer', $model->config['player'])->
            display('com_music_mypl.tpl');
    }

}
?>